;;*******************************************************************
;;fonction "plug-in" pouvant s'executer sur un jeu de selection
;; enregistre le plug-in pour les blocs, les anneaux, les cercles, les formes, les textes etc...
;/plugg/zoom succesifs sur une selection d'entit/none
(pw_pluggin_register '("CrossEntityZoom" ("INSERT" "DONUT" "CIRCLE" "SHAPE" "TEXT" "MTEXT" "POINT" "LINE" "MLINE" "LWPOLYLINE" "ARC" "ELLIPSE")
						("zoom succesifs sur une selection d'entit" "Deux icone en Z avec un flche permetent d'aller en avant ou en arrire"
						 "Zoom accross a selection of entities" "Use Z back an next arrow to run accross selection")
						)
)
;;definition de la commande
(defun CrossEntityZoom ( / lval blsel1 blsel pz zch l zt-lblsel)
 ;;ecartes les blocs definis dans l'espace papier
 (if (setq blsel1 (ssget "_p" (list '(-4 . "<NOT")'(67 . 1)'(-4 . "NOT>") )))
  (setq zt-lblsel (pw_listsel blsel1))
 )
 (setq zt-i 0)
 ;;
 (setq zt-l-pt-zoom
	(mapcar '(lambda (x)
	           (PW_scg2scu (cdr (assoc 10 (entget x))))
		  )
		  zt-lblsel
        )
 )

 (foreach pz  zt-l-pt-zoom
	 (command "_zoom" "_c" pz "")
	 (getstring "\nreturn pour suivant ou esc pour fin")
	 (setq zt-i (+ zt-i 1))
 )
)
;*******************************************************************
;;/plugg/recherche une chaine de texte dans un jeu de selection, puis zoom succesifs/none
;;fonction "plug-in" pouvant s'executer sur un jeu de selection
;; enregistre le plug-in pour les blocs
(pw_pluggin_register '( "CrossStringZoom" ("TEXT" "MTEXT")
						("zoom succesifs sur une selection de texte contenant une chaine" "Deux icone en Z avec un flche permetent d'aller en avant ou en arrire"
						 )
					  )
)
;;definition de la commande
(defun CrossStringZoom ( / lval blsel1 blsel pz  l)
 (pw_getstringmem  "\nChaine  rechercher" "zt-ch")
 ;;ecartes les blocs definis dans l'espace papier
 (ssget "_p" (list '(-4 . "<NOT")'(67 . 1)'(-4 . "NOT>") ))
  
 (if (setq blsel1 (ssget "P" (list '(-4 . "<OR")'(0 . "mtext")'(0 . "text")'(-4 . "OR>")(cons 1 zt-ch))))
  (setq zt-lblsel (append zt-lbsel (pw_listsel blsel1)))
 )
 (setq zt-i 0)
 (setq zt-l-pt-zoom
	(mapcar '(lambda (x)
	           (PW_scg2scu (cdr (assoc 10 (entget x))))
		  )
		  zt-lblsel
        )
 )

 (foreach pz  zt-l-pt-zoom
	 (command "_zoom" "_c" pz "")
	 (getstring "\nreturn pour suivant ou esc pour fin")
	 (setq zt-i (+ zt-i 1))
 )
)

;;*******************************************************************
;;/plugg/ fait un zoom sur l'entit suivante/none

(defun c:z+ ( /  )
  (while T
	 (setq zt-i (+ zt-i 1))
	 (command "_zoom" "_c" (pw_nthc zt-i zt-l-pt-zoom) "")
	 (getstring "\nreturn pour suivant ou esc pour fin")
  )
)
;;*******************************************************************
;;/plugg/ fait un zoom sur l'entit prcdente/none

(defun c:z- ( /  )
  (while T
	 (setq zt-i (- zt-i 1))
	 (command "_zoom" "_c" (pw_nthc zt-i zt-l-pt-zoom) "")
	 (getstring "\nreturn pour prcdant ou esc pour fin")
  )
)
;;*******************************************************************
;;/plugg/ fait un zoom sur l'entit suivante  partir du menu/none
;;il est important que la commande commence par m, car 'm n'est pas un alias autocad

(defun c:mparcourirzs ( / pz )
	 (setq zt-i (+ zt-i 1))
	 (setq pz (PW_scg2scu (cdr (assoc 10 (entget (pw_nthc zt-i zt-lblsel))))))
	 (command "_zoom" "_c" pz "")
)
;;*******************************************************************
;;/plugg/ fait un zoom sur l'entit prcdente partir du menu/none
;;il est important que la commande commence par m, car 'm n'est pas un alias autocad

(defun c:mparcourirzp ( / pz )
	 (setq zt-i (- zt-i 1))
	 (setq pz (PW_scg2scu (cdr (assoc 10 (entget (pw_nthc zt-i zt-lblsel))))))
	 (command "_zoom" "_c" pz "")
)

;;*******************************************************************
;;/plugg/ prpare une srie de zoom sur un zone rectangulaire/none
;;la taille de la fenetre est demande aprs

(defun c:zoomzone ( / pz lval blsel1 blsel  zch l zt-lblsel 4p 4pf pfb pzb pzh xdec ydec nbcol nbrang derent xcadre ycadre selpt)
  (prompt "\nCadrez la zone  couvrir:")
  (setq 4p (pw_saisie_rectang))
  (setq angltrav (angle (car 4p) (cadr 4p)))
  (pw_setvar1 "snapang" angltrav)
  (setq pzb (car 4p))
  (setq pzh (caddr 4p))
  
;;;  (setq pzb (getpoint "\nCoin bas gauche du cadre"))
;;;  (setq pzh (getcorner pzb "\nCoin haut droit du cadre"))
  (prompt "\nCadrez la taille de la fenetre du zoom:")
;;;  (setq pfb (getpoint "\nCoin bas gauche fenetre"))
;;;  (setq pfh (getcorner pfb "\nCoin haut droit fenetre"))
  ;;cadre
;;;  (setq vcadre (pw_p1-p2 pzh pzb))
;;;  (setq xcadre (car vcadre))
;;;  (setq ycadre (cadr vcadre))
  (setq xcadre (distance (cadr 4p) pzb))
  (setq ycadre (distance (car 4p) (last 4p)))

  ;;fenetre zoom
  (setq 4pf (pw_saisie_rectang))
  (setq pfb (car 4pf))
  (setq pfh (caddr 4pf))
  (setq xdec (* 0.8 (distance (cadr 4pf) pfb)))
  (setq ydec (* 0.8 (distance (car 4pf) (last 4pf))));
  
;;;  (setq V0 (pw_p1-p2 pfh pfb))
;;;  (setq xdec (* 0.8 (car V0)))
;;;  (setq ydec (* 0.8 (cadr V0)));
  ;tableau
  (setq nbcol (atoi (rtos (/ xcadre xdec) 2 0)))
  (setq nbrang (atoi (rtos (/ ycadre ydec) 2 0)))

  ;;tableau
  (setq derent (pw_real_entlast))
  (command "_point" (pw_prp pzb (/ xdec 2.0) (/ ydec 2.0)))
  (command "_array" (eval (entlast)) "")
  (command "_r" nbrang nbcol ydec xdec)
  (setq selpt (pw_selafter derent))
  (sssetfirst selpt selpt)
  (command "_zoom" "_w" pfb pfh)

 ;;la suite correspond  cross_entity_zoom !
 ;;ecartes les blocs definis dans l'espace papier
 (if (setq blsel1 (ssget "_p" (list '(-4 . "<NOT")'(67 . 1)'(-4 . "NOT>") )))
  (setq zt-lblsel (pw_listsel blsel1))
 )
 (setq zt-i 0)
 ;;
 (setq zt-l-pt-zoom
	(mapcar '(lambda (x)
	           (PW_scg2scu (cdr (assoc 10 (entget x))))
		  )
		  zt-lblsel
        )
 )
 (command "_erase" "_p" "")
 (foreach pz  zt-l-pt-zoom
	 (command "_zoom" "_c" pz "")
	 (getstring "\nreturn pour suivant ou esc pour fin")
	 (setq zt-i (+ zt-i 1))
 )
 (pw_setvar2 "snapang" )

)  

(defun c:trajet ()
  (command "_pline")
  (mapcar 'command zt-l-pt-zoom)
  (command "")
)