;*******************************************************************************
;; ENT_SCALE
;;/plugg/change l'echelle globale d'une selection d'entit - change scale of a selection of entities./none
;; register this plug-in for both linear and nodal entities that have a 10 code
(pw_pluggin_register '("ent_scale" ("POLYLINE" "LWPOLYLINE" "LINE" "REGION" "RECTANG" "POLYGONE" "INSERT" "SHAPE" "TEXT" "MTEXT" "CIRCLE" "ELLIPSE")
						("change l'echelle globale d'une selection d'entit" " - " "change scale of a selection of entities")
					 )
)
;;definition de la commande - function definition
(defun ent_scale ( / sel1 l eg pb )
;; store used value in vx, so vx keep global
 (pw_getrealmem "\nEchelle en globale voulue" "vx")

 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p")))
 (foreach l sell
  (setq eg (entget l))
  (if (/= 0 vx)
   (progn
    (setq pb (PW_scg2scu (cdr (assoc 10 eg))))
    (command "_scale" l "" pb vx)
   )
  )
 )
)
;*******************************************************************************
;;/blocs/change l'echelle x et y d'une selection de blocs/none
;;sans s'occuper de la valeur d'origine.
(pw_pluggin_register '( "x-y_scale" ( "INSERT" )
		       ("change l'echelle x et y d'une selection de blocs" "sans s'occuper de la valeur d'origine"
			"change x an y scale of a selction set of bloc" "no matter what was this scale before")))
;;
(defun x-y_scale ( / sel sel1 l eg ex ey )
 (pw_getrealmem "\nEchelle en x voulue <0 = inchange>" "vx")
 (pw_getrealmem "\nEchelle en y voulue <0 = inchange>" "vy")

 ;;selection obtenue avant (par powerclic)
 (setq sel (ssget "_p"))
 (setq sell (pw_listsel sel))
 (foreach l sell
  (setq eg (entget l))
  (if (/= 0 vx)
   (progn
    (setq ex (assoc 41 eg))
    (setq eg (subst (cons 41 vx) ex eg))
   )
  )
  (if (/= 0 vy)
   (progn
    (setq ey (assoc 42 eg))
    (setq eg (subst (cons 42 vy) ey eg))
   )
  )
  (entmod eg)
  (entupd l)
 )
)

;*******************************************************************************
;; all_same_scale
;;/plugg/uniformise l'echelle d'une selection d'entit - standardize scale of a selection of entities./none
;; register this plug-in for entities that have scale or size
(pw_pluggin_register '("all_same_scale" ( "INSERT" ) ("uniformise l'echelle d'une selection d'entit" "-" "standardize scale of a selection of entities" )))
;;definition de la commande - function definition
(defun all_same_scale ( / sel1 l eg  x y z l-scale)

 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p")))

 (setq eg (entget (car (entsel "\nPick reference insert :"))))
 (setq x (assoc 41 eg))
 (setq y (assoc 42 eg))
 (setq z (assoc 43 eg))
 (setq l-scale (list x y z))
  

 (foreach l sell
  (setq eg (entget l))
  (setq eg (pw_subst_new_assoc l-scale eg))
  (entmod eg)
  (entupd l)
 )
)
;*******************************************************************************
;; all_same_size
;;/plugg/uniformise la taille d'une selection d'entit - standardize size of a selection of entities./none
;; register this plug-in for entities that have scale or size
(pw_pluggin_register '("all_same_size" ( "TEXT" "MTEXT" )("uniformise la taille d'une selection d'entit" "-" "standardize size of a selection of entities" )))
;;definition de la commande - function definition
(defun all_same_size ( / sell l eg  x  l-scale)

 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p")))

 (setq eg (entget (car (entsel "\nPick reference text :"))))
 (setq x (assoc 40 eg))
 (setq l-scale (list x ))
  

 (foreach l sell
  (setq eg (entget l))
  (setq eg (pw_subst_new_assoc l-scale eg))
  (entmod eg)
  (entupd l)
 )
)

;*******************************************************************************
;; range_size_to_all_same_size
;;/plugg/uniformise la taille d'une selection d'entit - standardize size of a selection of entities./none
;; register this plug-in for entities that have scale or size
(pw_pluggin_register '("range_size_to_all_same_size" ( "TEXT" "MTEXT" "CIRCLE") ("uniformise la taille d'une selection d'entit" "-" "standardize size of a selection of entities" )))
;;definition de la commande - function definition
(defun range_size_to_all_same_size ( / sell l eg  x xh xb l-scale lf sel range)

 (setq eg (entget (car (entsel "\nPick lowest size entity :"))))
 (setq xb (cdr (assoc 40 eg)))
 (setq eg (entget (car (entsel "\nPick bigest size entity :"))))
 (setq xh (cdr (assoc 40 eg)))
 (setq range (expt 10 (- (getvar "luprec"))))
 (setq xh (+ xh range))
 (setq xb (- xb range))
 (setq lf (list '(-4 . ">=")(cons 40 xb)'(-4 . "<=")(cons 40 xh)))
 
 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p" lf)))

 ;;taille moyenne
 (setq x (/ (+ xb xh) 2.0))
 (setq x (rtos x 2 (getvar "luprec")))
 (setq x (atof x)) 
 (pw_getrealmem "\nNew size or radius ?" "x")
 (setq l-scale (list (cons 40 x)))
 (setq sel (ssadd))  

 (foreach l sell
  (setq eg (entget l))
  (setq eg (pw_subst_new_assoc l-scale eg))
  (print (entmod eg))
  (entupd l)
  (setq sel (ssadd l sel))
 )
  (sssetfirst sel sel) 
)

;*******************************************************************************
;; round_to_luprec
;;/plugg/arrondie la taille d'une selection d'entit ajustes  la valeur de LUPREC- round size of a selection of entities according to luprec./none
;; register this plug-in for entities that have scale or size
(pw_pluggin_register '("round_to_luprec" ( "TEXT" "MTEXT" "CIRCLE")("arrondie la taille d'une selection d'entit ajustes  la valeur de LUPREC" "-" "round size of a selection of entities according to LUPREC" )))
;;definition de la commande - function definition
(defun round_to_luprec ( / sell l eg  x  sel )

  ;;dessou pour voir comment selectionner directement par luprec
;;; (setq eg (entget (car (entsel "\nPick reference entity :"))))
;;; (setq range (expt 10 (- (getvar "luprec"))))
;;; (setq xh (+ x range))
;;; (setq xb (- x range))
;;; (setq lf (list '(-4 . ">=")(cons 40 xb)'(-4 . "<=")(cons 40 xh)))
 
 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p")))
 
 (setq sel (ssadd))  

 (foreach l sell
  (setq eg (entget l))
  ;;recalibre la valeur trop precise
  (setq x (cdr (assoc 40 eg)))
  (setq x (rtos x 2 (getvar "luprec")))
  (setq x (atof x)) 
  (setq eg (pw_subst_new_assoc (list (cons 40 x)) eg))
  (entmod eg)
  (entupd l)
  (setq sel (ssadd l sel))
 )
  (sssetfirst sel sel) 
)
;*******************************************************************************
;; round_width_to_luprec_
;;/plugg/arrondie la taille d'une selection d'entit ajustes  la valeur de LUPREC- round size of a selection of entities according to luprec./none
;; register this plug-in for entities that have scale or size
(pw_pluggin_register '("round_width_to_luprec_" ( "LWPOLYLINE" "POLYGON" "RECTANG")("arrondie l'epaisseur d'une selection de polylignes ajustes  la valeur de LUPREC" "-" "round size of a selection of entities according to LUPREC" )))
;;definition de la commande - function definition
(defun round_width_to_luprec_ ( / sell l eg  x  sel )
 
 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p")))
 
 (setq sel (ssadd))  

 (foreach l sell
  (setq eg (entget l))
  ;;recalibre la valeur trop precise
  (setq x (cdr (assoc 43 eg)))
  (setq x (rtos x 2 (getvar "luprec")))
  (setq x (atof x)) 
  (setq eg (pw_subst_new_assoc (list (cons 43 x)) eg))
  (entmod eg)
  (entupd l)
  (setq sel (ssadd l sel))
 )
  (sssetfirst sel sel) 
)
;*******************************************************************************
;; 3d_rotate
;;/plugg/rotation individuelle pour aligner avec le scu/none
(pw_pluggin_register '("3d_rotate_x" ( "INSERT" "SHAPE" "TEXT" "MTEXT")
						("rotation 3d individuelle pour aligner avec le scu" "par rapport au point d'insertion"
						 "-" "Rotate each entity around the x axis of its insertion point"
						 "warning : Autocad 3drotate command must be loaded")
					 )
)
;;definition de la commande - function definition
(defun 3d_rotate_x ( / sell l eg pb )
;; store used value in vx, so vx keep global
 (pw_getrealmem "\nRotation angle around X axis" "ar")
 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p")))
 (sssetfirst nil)
 (foreach l sell
  (setq eg (entget l))
  (setq pb (PW_sco2scu (cdr (assoc 10 eg)) l ))
    ;;(command "_rotate3d" pause "" "_Xaxis"  pause pause)
    ;(rotate3d l (pw_scu2scg pb) (pw_scu2scg(pw_prp pb 1 0)) ar)
    (command "_rotate3d" l "" "_Xaxis" pb ar)
 )
)
;*******************************************************************************
;; 3d_rotate
;;/plugg/rotation individuelle pour aligner avec le scu/none
(pw_pluggin_register '("3d_rotate_y" ( "INSERT" "SHAPE" "TEXT" "MTEXT")
						("rotation 3d individuelle pour aligner avec le scu" "par rapport au point d'insertion"
						 "-" "Rotate each entity around the y axis of its insertion point"
						 "warning : Autocad 3drotate command must be loaded")
					 )
)
;;definition de la commande - function definition
(defun 3d_rotate_y ( / sell l eg pb )
;; store used value in vx, so vx keep global
 (pw_getrealmem "\nRotation angle around Y axis" "ar")
 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p")))
 (sssetfirst nil)
 (foreach l sell
  (setq eg (entget l))
  (setq pb (PW_sco2scu (cdr (assoc 10 eg)) l ))
    (command "_rotate3d" l "" "_Yaxis" pb ar)
 )
)

;*******************************************************************************
;; ENT_rotate
;;/plugg/change l'echelle globale d'une selection d'entit - change scale of a selection of entities./none
;; register this plug-in for both linear and nodal entities that have a 10 code
(pw_pluggin_register '("ent_rotate" ("POLYLINE" "LWPOLYLINE" "LINE" "REGION" "RECTANG"  "INSERT" "SHAPE" "TEXT" "MTEXT"  "ELLIPSE")
						("Rotation d'un objet par rapport  son point d'insertion" " - " "Rotation of entities based on their insertion point")
					 )
)
;;definition de la commande - function definition
(defun ent_rotate ( / sel1 l eg pb )
;; store used value in vx, so vx keep global
 (pw_getrealmem "\nRotation globale voulue" "vr")

 ;;selection obtenue avant (par powerclic)
 (setq sell (pw_listsel (ssget "_p")))
 (foreach l sell
  (setq eg (entget l))
  (if (/= 0 vx)
   (progn
    (cond
      ((= "TEXT" (cdr (assoc 0 eg)))
       (if (/= "ligne_de_basegauche" (pw_exprime_justification eg))
        (setq pb (PW_scg2scu (cdr (assoc 11 eg))))
        (setq pb (PW_scg2scu (cdr (assoc 10 eg))))
       )
      )
      (T
      (setq pb (PW_scg2scu (cdr (assoc 10 eg))))
      )
    )
    (command "_rotate" l "" pb vr)
   )
  )
 )
)
